QwtPicker(3)

NAME
QwtPicker -

SYNOPSIS

Inherits QwtEventPattern.

Inherited by QwtPlotPicker.

Detailed Description

QwtPicker provides selections on a widget. QwtPicker filters all mouse and keyboard events of a widget and translates them into an array of selected points. Depending on the QwtPicker::SelectionType the selection might be a single point, a rectangle or a polygon. The selection process is supported by optional rubberbands (rubberband selection) and position labels.

QwtPicker is useful for widgets where the event handlers canīt be overloaded, like for components of composite widgets. It offers alternative handlers for mouse and key events.

Example .RS 4

 #include <qwt_picker.h>
QwtPicker *picker = new QwtPicker(widget);
picker->setCursorLabelMode(QwtPicker::ActiveOnly);
connect(picker, SIGNAL(selected(const QPointArray &)), ...);
// emit the position of clicks on widget
picker->setSelectionFlags(QwtPicker::PointSelection | QwtPicker::ClickSelection);
    ...

// now select rectangles
picker->setSelectionFlags(QwtPicker::RectSelection | QwtPicker::DragSelection);
picker->setRubberBand(QwtPicker::RectRubberBand);

The selection process uses the commands begin(), append(), move() and end(). append() adds a new point to the selection, move() changes the position of the latest point.

The commands are initiated from a small state machine (QwtPickerMachine) that translates mouse and key events. There are a couple of predefined state machines for point, rect and polygon selections. The selectionFlags() control which one should be used. It is possible to use other machines by overloading stateMachine().

The picker is active (isActive()), between begin() and end(). In active state the rubberband is displayed, and the cursor label is visible in case of cursorLabelMode is ActiveOnly or AlwaysOn.

The cursor can be moved using the arrow keys. All selections can be aborted using the abort key. (QwtEventPattern::KeyPatternCode)

Warning:
    In case of QWidget::NoFocus the focus policy of the observed widget is set to QWidget::WheelFocus and mouse tracking will be manipulated for ClickSelection while the picker is active, or if cursorLabelMode() is AlwayOn.

Definition at line 79 of file qwt_picker.h.

  Public Types
enum SelectionType { NoSelection = 0, PointSelection = 1, RectSelection = 2, PolygonSelection = 4 }
enum RectSelectionType { CornerToCorner = 64, CenterToCorner = 128, CenterToRadius = 256 }
enum SelectionMode { ClickSelection = 1024, DragSelection = 2048 }
enum RubberBand { NoRubberBand = 0, HLineRubberBand, VLineRubberBand, CrossRubberBand, RectRubberBand, EllipseRubberBand, PolygonRubberBand, UserRubberBand = 100 }
enum DisplayMode { AlwaysOff, AlwaysOn, ActiveOnly }
enum ResizeMode { Stretch, KeepSize }

  Signals
void selected (const QPointArray &pa)
void appended (const QPoint &pos)
void moved (const QPoint &pos)
void changed (const QPointArray &pa)

  Public Member Functions
QwtPicker (QWidget *, const char *name=0)
QwtPicker (int selectionFlags, RubberBand rubberBand, DisplayMode cursorLabelMode, QWidget *, const char *name=0)
virtual ~QwtPicker ()
virtual void setSelectionFlags (int)
int selectionFlags () const
virtual void setRubberBand (RubberBand)
RubberBand rubberBand () const
virtual void setCursorLabelMode (DisplayMode)
DisplayMode cursorLabelMode () const
virtual void setResizeMode (ResizeMode)
ResizeMode resizeMode () const
virtual void setRubberBandPen (const QPen &)
QPen rubberBandPen () const
virtual void setCursorLabelPen (const QPen &)
QPen cursorLabelPen () const
virtual void setCursorLabelFont (const QFont &)
QFont cursorLabelFont () const
bool isEnabled () const
virtual void setEnabled (bool)
bool isActive () const
virtual bool eventFilter (QObject *, QEvent *)
QWidget * parentWidget ()
const QWidget * parentWidget () const
virtual QRect pickRect () const
const QPointArray & selection () const
virtual bool event (QEvent *)

  Protected Member Functions
virtual bool accept (QPointArray &selection) const
virtual void transition (const QEvent *)
virtual void begin ()
virtual void append (const QPoint &)
virtual void move (const QPoint &)
virtual bool end (bool ok=TRUE)
virtual void widgetMousePressEvent (QMouseEvent *)
virtual void widgetMouseReleaseEvent (QMouseEvent *)
virtual void widgetMouseDoubleClickEvent (QMouseEvent *)
virtual void widgetMouseMoveEvent (QMouseEvent *)
virtual void widgetWheelEvent (QWheelEvent *)
virtual void widgetKeyPressEvent (QKeyEvent *)
virtual void widgetKeyReleaseEvent (QKeyEvent *)
virtual void drawRubberBand (const QRect &clipRect=QRect()) const
virtual void drawRubberBand (QPainter *, const QRect &rect, const QPointArray &) const
virtual void drawCursorLabel (const QRect &clipRect=QRect()) const
virtual void drawCursorLabel (QPainter *, const QRect &rect, const QPoint &, const QPointArray &) const
virtual void stretchSelection (const QSize &oldSize, const QSize &newSize)
virtual QString cursorLabel (const QPoint &pos) const
virtual QwtPickerMachine * stateMachine (int) const
void repaint (const QRect &rect=QRect())

Member Enumeration Documentation

  enum QwtPicker::DisplayMode

•   AlwaysOff
     Display never.

•   AlwaysOn
     Display always.

•   ActiveOnly
     Display only when the selection is active.

See also:
    QwtPicker::setCursorLabelMode(), QwtPicker::cursorLabelMode(), QwtPicker::isActive()

Definition at line 223 of file qwt_picker.h.

Referenced by cursorLabelMode().

  enum QwtPicker::RectSelectionType

Selection subtype for RectSelection This enum type describes the type of rectangle selections. It can be orīd with QwtPicker::RectSelectionType and QwtPicker::SelectionMode and passed to QwtPicker::setSelectionFlags().

•   CornerToCorner
     The first and the second selected point are the corners of the rectangle.

•   CenterToCorner
     The first point is the center, the second a corner of the rectangle.

•   CenterToRadius
     The first point is the center of a quadrat, calculated by the maximum of the x- and y-distance.

The default value is CornerToCorner.

See also:
    QwtPicker::setSelectionFlags(), QwtPicker::selectionFlags()

Definition at line 149 of file qwt_picker.h.

  enum QwtPicker::ResizeMode

Controls what to do with the selected points of an active selection when the observed widget is resized.

•   Stretch
     All points are scaled according to the new size,

•   KeepSize
     All points remain unchanged.

The default value is Stretch.

See also:
    QwtPicker::setResizeMode(), QwtPicker::resize()

Definition at line 242 of file qwt_picker.h.

Referenced by resizeMode().

  enum QwtPicker::RubberBand

Rubberband style

•   NoRubberBand
     No rubberband.

•   HLineRubberBand & PointSelection
     A horizontal line.

•   VLineRubberBand & PointSelection
     A vertical line.

•   CrossRubberBand & PointSelection
     A horizontal and a vertical line.

•   RectRubberBand & RectSelection
     A rectangle.

•   EllipseRubberBand & RectSelection
     An ellipse.

•   PolygonRubberBand &PolygonSelection
     A polygon.

•   UserRubberBand
     Values >= UserRubberBand can be used to define additional rubber bands.

The default value is NoRubberBand.

See also:
    QwtPicker::setRubberBand(), QwtPicker::rubberBand()

Definition at line 193 of file qwt_picker.h.

Referenced by rubberBand().

  enum QwtPicker::SelectionMode

Values of this enum type orīd together with a SelectionType value identifies which state machine should be used for the selection.

The default value is ClickSelection.

See also:
    stateMachine()

Definition at line 163 of file qwt_picker.h.

  enum QwtPicker::SelectionType

This enum type describes the type of a selection. It can be orīd with QwtPicker::RectSelectionType and QwtPicker::SelectionMode and passed to QwtPicker::setSelectionFlags()

•   NoSelection
     Selection is disabled. Note this is different to the disabled state, as you might have a cursor label.

•   PointSelection
     Select a single point.

•   RectSelection
     Select a rectangle.

•   PolygonSelection
     Select a polygon.

The default value is NoSelection.

See also:
    QwtPicker::setSelectionFlags(), QwtPicker::selectionFlags()

Definition at line 123 of file qwt_picker.h.

Constructor & Destructor Documentation

  QwtPicker::QwtPicker (QWidget * parent, const char * name = 0)

Constructor

Creates an picker that is enabled, but where selection flags s set to NoSelection, rubberband and cursor label are disabled.

Parameters:
    parent Parent widget, that will be observed
    name Object name

Definition at line 30 of file qwt_picker.cpp.

  QwtPicker::QwtPicker (int selectionFlags, RubberBand rubberBand, DisplayMode cursorLabelMode, QWidget * parent, const char * name = 0)

Constructor

Parameters:
    selectionFlags Orīd value of SelectionType, RectSelectionType and SelectionMode
    rubberBand Rubberband style
    cursorLabelMode Cursor label mode
    parent Parent widget, that will be observed
    name Object name

Definition at line 46 of file qwt_picker.cpp.

  QwtPicker::~QwtPicker () [virtual]

Destructor.

Definition at line 54 of file qwt_picker.cpp.

Member Function Documentation

  bool QwtPicker::accept (QPointArray & selection) const [protected, virtual]

Validate and fixup the selection.

Accepts all selections unmodified

Parameters:
    selection Selection to validate and fixup

Returns:
    TRUE, when accepted, FALSE otherwise

Reimplemented in QwtPlotZoomer.

Definition at line 1124 of file qwt_picker.cpp.

Referenced by end().

  void QwtPicker::append (const QPoint & pos) [protected, virtual]

Append a point to the selection and update rubberband and cursor label. The appended() signal is emitted.

Parameters:
    pos Additional point

See also:
    isActive, begin(), end(), move(), appended()

Reimplemented in QwtPlotPicker.

Definition at line 1082 of file qwt_picker.cpp.

References appended(), drawCursorLabel(), and drawRubberBand().

Referenced by QwtPlotPicker::append(), and transition().

  void QwtPicker::appended (const QPoint & pos) [signal]

A signal emitted when a point has been appended to the selection

Parameters:
    pos Position of the appended point.

See also:
    append(). moved()

Referenced by append().

  void QwtPicker::begin () [protected, virtual]

Open a selection setting the state to active

See also:
    isActive, end(), append(), move()

Reimplemented in QwtPlotZoomer.

Definition at line 1013 of file qwt_picker.cpp.

References cursorLabelMode(), drawCursorLabel(), and parentWidget().

Referenced by QwtPlotZoomer::begin(), and transition().

  void QwtPicker::changed (const QPointArray & pa) [signal]

A signal emitted when the active selection has been changed. This might happen when the observed widget is resized.

Parameters:
    pa Changed selection

See also:
    stretchSelection()

Referenced by stretchSelection().

  QString QwtPicker::cursorLabel (const QPoint & pos) const [protected, virtual]

Return the label for a position.

In case of HLineRubberBand the label is the value of the y position, in case of VLineRubberBand the value of the x position. Otherwise the label contains x and y position separated by a ī, ī.

The format for the string conversion is '%d'.

Parameters:
    pos Position

Returns:
    Converted position as string

Reimplemented in QwtPlotPicker.

Definition at line 408 of file qwt_picker.cpp.

References rubberBand().

Referenced by drawCursorLabel().

  QFont QwtPicker::cursorLabelFont () const

Returns:
    Cursor label font

See also:
    setCursorLabelFont(), cursorLabelMode(), cursorLabelPen()

Definition at line 336 of file qwt_picker.cpp.

  QwtPicker::DisplayMode QwtPicker::cursorLabelMode () const

Returns:
    Cursor label display mode

See also:
    setCursorLabelMode(), DisplayMode

Definition at line 240 of file qwt_picker.cpp.

References DisplayMode.

Referenced by begin(), drawCursorLabel(), and end().

  QPen QwtPicker::cursorLabelPen () const

Returns:
    Cursor label pen

See also:
    setCursorLabelPen(), cursorLabelMode(), cursorLabelFont()

Definition at line 365 of file qwt_picker.cpp.

  void QwtPicker::drawCursorLabel (QPainter * painter, const QRect & pickRect, const QPoint & pos, const QPointArray & pa) const [protected, virtual]

Draw a cursor label.

The default position of the label is top-right of the cursor. In case of a rubberband the label is placed not to conflict with the rubberband.

Parameters:
    painter Painter, initialized with clip rect, in Qt::XorROP mode of cursor label pen and background color of the observed widget.
    pickRect Rectangle where selections can happen.
    pos Cursor position
    pa Current selection

See also:
    rubberBand(), RubberBand, selectionFlags()

Definition at line 627 of file qwt_picker.cpp.

References QwtText::boundingRect(), cursorLabel(), QwtText::draw(), isActive(), QwtText::makeText(), and rubberBand().

  void QwtPicker::drawCursorLabel (const QRect & clipRect = QRect()) const [protected, virtual]

Draw the cursor label.

The cursor label is painted in Qt::XorROP mode, what means the first call paints the second erases the painted rubberband.

Parameters:
    clipRect Clipping rectangle. If it is now valid the result of pickRect() is used instead.

See also:
    pickRect(), QPainter::setRasterOp(), QPainter::setClipRect()

Definition at line 580 of file qwt_picker.cpp.

References cursorLabelMode(), isActive(), parentWidget(), and pickRect().

Referenced by append(), begin(), end(), event(), eventFilter(), setCursorLabelFont(), setCursorLabelPen(), setEnabled(), widgetMouseMoveEvent(), and widgetWheelEvent().

  void QwtPicker::drawRubberBand (QPainter * painter, const QRect & pickRect, const QPointArray & pa) const [protected, virtual]

Draw a rubberband , depending on rubberBand() and selectionFlags()

Parameters:
    painter Painter, initialized with clip rect, in Qt::XorROP mode of rubberband pen and background color of the observed widget.
    pickRect Rectangle where selection can happen.
    pa Current selection

See also:
    rubberBand(), RubberBand, selectionFlags()

Definition at line 472 of file qwt_picker.cpp.

References QwtPainter::drawEllipse(), QwtPainter::drawLine(), QwtPainter::drawRect(), rubberBand(), and selectionFlags().

  void QwtPicker::drawRubberBand (const QRect & clipRect = QRect()) const [protected, virtual]

Draw the rubberband.

The rubberband is painted in Qt::XorROP mode, what means the first call paints the second erases the painted rubberband.

Parameters:
    clipRect Clipping rectangle. If it is now valid the result of pickRect() is used instead.

See also:
    pickRect(), QPainter::setRasterOp(), QPainter::setClipRect()

Definition at line 437 of file qwt_picker.cpp.

References isActive(), parentWidget(), pickRect(), rubberBand(), and rubberBandPen().

Referenced by append(), end(), event(), eventFilter(), move(), and setRubberBandPen().

  bool QwtPicker::end (bool ok = TRUE) [protected, virtual]

Close a selection setting the state to inactive.

The selection is validated and maybe fixed by QwtPicker::accept().

Parameters:
    ok If TRUE, complete the selection and emit a selected signal otherwise discard the selection.

Returns:
    TRUE if the selection is accepted, FALSE otherwise

See also:
    isActive, begin(), append(), move(), selected(), accept()

Reimplemented in QwtPlotPicker, and QwtPlotZoomer.

Definition at line 1044 of file qwt_picker.cpp.

References accept(), cursorLabelMode(), drawCursorLabel(), drawRubberBand(), and selected().

Referenced by QwtPlotPicker::end(), transition(), and widgetKeyPressEvent().

  bool QwtPicker::event (QEvent * e) [virtual]

Event Handler.

Paint events for the observed widgets require to repaint rubberband an cursor label too. To delay them until the widget is repainted the event filter sends a QEvent::Paint to the picker, that is handled here.

See also:
    repaint, eventFilter(), drawRubberBand(), drawCursorLabel()

Definition at line 702 of file qwt_picker.cpp.

References drawCursorLabel(), and drawRubberBand().

  bool QwtPicker::eventFilter (QObject * o, QEvent * e) [virtual]

Event filter.

When isEnabled() == TRUE all events of the observed widget are filtered. Mouse and keyboard events are translated into widgetMouse- and widgetKey- and widgetWheel-events. Paint and Resize events are handled to keep rubberband and cursor label up to date.

See also:
    event(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

Definition at line 728 of file qwt_picker.cpp.

References drawCursorLabel(), drawRubberBand(), parentWidget(), repaint(), stretchSelection(), widgetKeyPressEvent(), widgetKeyReleaseEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetMousePressEvent(), widgetMouseReleaseEvent(), and widgetWheelEvent().

  bool QwtPicker::isActive () const

A picker is active between begin() and end().

Returns:
    TRUE if the selection is active.

Definition at line 1133 of file qwt_picker.cpp.

Referenced by drawCursorLabel(), drawRubberBand(), QwtPlotZoomer::widgetKeyPressEvent(), and widgetKeyPressEvent().

  bool QwtPicker::isEnabled () const

Returns:
    TRUE when enabled, FALSE otherwise

See also:
    setEnabled, eventFilter()

Definition at line 306 of file qwt_picker.cpp.

Referenced by setCursorLabelFont(), and setCursorLabelPen().

  void QwtPicker::move (const QPoint & pos) [protected, virtual]

Move the last point of the selection The moved() signal is emitted.

Parameters:
    pos New position

See also:
    isActive, begin(), end(), append()

Reimplemented in QwtPlotPicker.

Definition at line 1108 of file qwt_picker.cpp.

References drawRubberBand(), and moved().

Referenced by QwtPlotPicker::move(), and transition().

  void QwtPicker::moved (const QPoint & pos) [signal]

A signal emitted whenever the last appended point of the selection has been moved.

Parameters:
    pos Position of the moved last point of the selection.

See also:
    move(), appended()

Referenced by move().

  const QWidget * QwtPicker::parentWidget () const

Return the parent widget, where the selection happens.

Definition at line 155 of file qwt_picker.cpp.

  QWidget * QwtPicker::parentWidget ()

Return the parent widget, where the selection happens.

Definition at line 145 of file qwt_picker.cpp.

Referenced by begin(), QwtPlotPicker::canvas(), drawCursorLabel(), drawRubberBand(), eventFilter(), pickRect(), setEnabled(), transition(), and widgetKeyPressEvent().

  QRect QwtPicker::pickRect () const [virtual]

Find the area of the observed widget, where selection might happen.

Returns:
    QFrame::contentsRect() if it is a QFrame, QWidget::rect() otherwise.

Definition at line 1205 of file qwt_picker.cpp.

References parentWidget().

Referenced by drawCursorLabel(), drawRubberBand(), widgetKeyPressEvent(), widgetMouseMoveEvent(), and widgetWheelEvent().

  void QwtPicker::repaint (const QRect & rect = QRect()) [protected]

Repaint cursor label and rubberband on top of the widget.

Send a QEvent::Paint event to the picker

Parameters:
    rect Rectangle which has to be repainted. In case of !rect.isValid() a complete repaint ill be initiated.

Definition at line 687 of file qwt_picker.cpp.

Referenced by eventFilter().

  QwtPicker::ResizeMode QwtPicker::resizeMode () const

Returns:
    Resize mode

See also:
    setResizeMode(), ResizeMode

Definition at line 269 of file qwt_picker.cpp.

References ResizeMode.

  QwtPicker::RubberBand QwtPicker::rubberBand () const

Returns:
    Rubberband style

See also:
    setRubberBand(), RubberBand, rubberBandPen()

Definition at line 206 of file qwt_picker.cpp.

References RubberBand.

Referenced by QwtPlotPicker::cursorLabel(), cursorLabel(), drawCursorLabel(), and drawRubberBand().

  QPen QwtPicker::rubberBandPen () const

Returns:
    Rubberband pen

See also:
    setRubberBandPen(), rubberBand()

Definition at line 390 of file qwt_picker.cpp.

Referenced by drawRubberBand().

  void QwtPicker::selected (const QPointArray & pa) [signal]

A signal emitting the selected points, at the end of a selection.

Parameters:
    pa Selected points

Referenced by end().

  const QPointArray & QwtPicker::selection () const

Return Selected points.

Definition at line 1139 of file qwt_picker.cpp.

Referenced by QwtPlotZoomer::end(), and QwtPlotPicker::end().

  int QwtPicker::selectionFlags () const

Returns:
    Selection flags, an Orīd value of SelectionType, RectSelectionType and SelectionMode.

See also:
    setSelectionFlags(), SelectionType, RectSelectionType, SelectionMode

Definition at line 184 of file qwt_picker.cpp.

Referenced by drawRubberBand(), and QwtPlotPicker::end().

  void QwtPicker::setCursorLabelFont (const QFont & font) [virtual]

Set the font for the cursor label

Parameters:
    font Cursor label font

See also:
    cursorLabelFont(), setCursorLabelMode(), setCursorLabelPen()

Definition at line 317 of file qwt_picker.cpp.

References drawCursorLabel(), and isEnabled().

  void QwtPicker::setCursorLabelMode (DisplayMode mode) [virtual]

Set the display mode of the cursor label.

A cursor label dispays the current position of the cursor as a string. The display mode controls if the label has to be displayed whenever the observed widget has focus and cursor (AlwaysOn), never (AlwaysOff), or only when the selection is active (ActiveOnly).

Parameters:
    mode Cursor label display mode

Warning:
    In case of AlwaysOn, mouseTracking will be enabled for the observed widget.

See also:
    cursorLabelMode(), DisplayMode

Definition at line 227 of file qwt_picker.cpp.

  void QwtPicker::setCursorLabelPen (const QPen & pen) [virtual]

Set the pen for the cursor label

Parameters:
    pen Cursor label pen

See also:
    cursorLabelPen(), setCursorLabelMode(), setCursorLabelFont()

Definition at line 347 of file qwt_picker.cpp.

References drawCursorLabel(), and isEnabled().

  void QwtPicker::setEnabled (bool enabled) [virtual]

En/disable the picker.

When enabled is TRUE an event filter is installed for the observed widget, otherwise the event filter is removed.

Parameters:
    enabled TRUE or FALSE

See also:
    isEnabled(), eventFilter()

Definition at line 283 of file qwt_picker.cpp.

References drawCursorLabel(), and parentWidget().

  void QwtPicker::setResizeMode (ResizeMode mode) [virtual]

Set the resize mode.

The resize mode controls what to do with the selected points of an active selection when the observed widget is resized.

Stretch means the points are scaled according to the new size, KeepSize means the points remain unchanged.

The default mode is Stretch.

Parameters:
    mode Resize mode

See also:
    resizeMode(), ResizeMode

Definition at line 259 of file qwt_picker.cpp.

  void QwtPicker::setRubberBand (RubberBand rubberBand) [virtual]

Set the rubberband style

Parameters:
    rubberBand Rubberband style The default value is NoRubberBand.

See also:
    rubberBand(), RubberBand, setRubberBandPen()

Definition at line 197 of file qwt_picker.cpp.

  void QwtPicker::setRubberBandPen (const QPen & pen) [virtual]

Set the pen for the rubberband

Parameters:
    pen Rubberband pen

See also:
    rubberBandPen(), setRubberBand()

Definition at line 376 of file qwt_picker.cpp.

References drawRubberBand().

  void QwtPicker::setSelectionFlags (int flags) [virtual]

Set the selection flags

Parameters:
    flags Orīd value of SelectionType, RectSelectionType and SelectionMode. The default value is NoSelection.

See also:
    selectionFlags(), SelectionType, RectSelectionType, SelectionMode

Reimplemented in QwtPlotZoomer.

Definition at line 173 of file qwt_picker.cpp.

References stateMachine().

Referenced by QwtPlotZoomer::setSelectionFlags().

  QwtPickerMachine * QwtPicker::stateMachine (int flags) const [protected, virtual]

Create a state machine depending on the selection flags.

•   PointSelection | ClickSelection
     QwtPickerClickPointMachine()

•   PointSelection | DragSelection
     QwtPickerDragPointMachine()

•   RectSelection | ClickSelection
     QwtPickerClickRectMachine()

•   RectSelection | DragSelection
     QwtPickerDragRectMachine()

•   PolygonSelection
     QwtPickerPolygonMachine()

See also:
    setSelectionFlags()

Definition at line 121 of file qwt_picker.cpp.

Referenced by setSelectionFlags().

  void QwtPicker::stretchSelection (const QSize & oldSize, const QSize & newSize) [protected, virtual]

Scale the selection by the ratios of oldSize and newSize The changed() signal is emitted.

Parameters:
    oldSize Previous size
    newSize Current size

See also:
    ResizeMode, setResizeMode(), resizeMode()

Definition at line 1153 of file qwt_picker.cpp.

References changed().

Referenced by eventFilter().

  void QwtPicker::transition (const QEvent * e) [protected, virtual]

Passes an event to the state machine and executes the resulting commands. Append and Move commands use the current position of the cursor (QCursor::pos()).

Parameters:
    e Event

Definition at line 970 of file qwt_picker.cpp.

References append(), begin(), end(), move(), parentWidget(), and QwtPickerMachine::transition().

Referenced by widgetKeyPressEvent(), widgetKeyReleaseEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetMousePressEvent(), widgetMouseReleaseEvent(), and widgetWheelEvent().

  void QwtPicker::widgetKeyPressEvent (QKeyEvent * ke) [protected, virtual]

Handle a key press event for the observed widget.

Selections can be completely done by the keyboard. The arrow keys move the cursor, the abort key aborts a selection. All other keys are handled by the current state machine.

See also:
    QwtPicker, selectionFlags()

    eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetWheelEvent(), widgetKeyReleaseEvent(), stateMachine(), QwtEventPattern::KeyPatternCode

Reimplemented in QwtPlotZoomer.

Definition at line 904 of file qwt_picker.cpp.

References end(), isActive(), QwtEventPattern::keyMatch(), parentWidget(), pickRect(), QwtPickerMachine::reset(), and transition().

Referenced by eventFilter(), and QwtPlotZoomer::widgetKeyPressEvent().

  void QwtPicker::widgetKeyReleaseEvent (QKeyEvent * ke) [protected, virtual]

Handle a key release event for the observed widget.

Passes the event to the state machine.

See also:
    eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetWheelEvent(), widgetKeyPressEvent(), stateMachine()

Definition at line 958 of file qwt_picker.cpp.

References transition().

Referenced by eventFilter().

  void QwtPicker::widgetMouseDoubleClickEvent (QMouseEvent * me) [protected, virtual]

Handle mouse double click event for the observed widget.

Empty implementation, does nothing.

See also:
    eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseMoveEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

Definition at line 861 of file qwt_picker.cpp.

References transition().

Referenced by eventFilter().

  void QwtPicker::widgetMouseMoveEvent (QMouseEvent * e) [protected, virtual]

Handle a mouse move event for the observed widget.

Move the last point of the selection in case of isActive() == TRUE

See also:
    eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

Definition at line 822 of file qwt_picker.cpp.

References drawCursorLabel(), pickRect(), and transition().

Referenced by eventFilter().

  void QwtPicker::widgetMousePressEvent (QMouseEvent * e) [protected, virtual]

Handle a mouse press event for the observed widget.

Begin and/or end a selection depending on the selection flags.

See also:
    QwtPicker, selectionFlags()

    eventFilter(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

Definition at line 808 of file qwt_picker.cpp.

References transition().

Referenced by eventFilter().

  void QwtPicker::widgetMouseReleaseEvent (QMouseEvent * e) [protected, virtual]

Handle a mouse relase event for the observed widget.

End a selection depending on the selection flags.

See also:
    QwtPicker, selectionFlags()

    eventFilter(), widgetMousePressEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

Reimplemented in QwtPlotZoomer.

Definition at line 847 of file qwt_picker.cpp.

References transition().

Referenced by eventFilter(), and QwtPlotZoomer::widgetMouseReleaseEvent().

  void QwtPicker::widgetWheelEvent (QWheelEvent * e) [protected, virtual]

Handle a wheel event for the observed widget.

Move the last point of the selection in case of isActive() == TRUE

See also:
    eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

Definition at line 876 of file qwt_picker.cpp.

References drawCursorLabel(), pickRect(), and transition().

Referenced by eventFilter().

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.